<?php

/**
 * @package		myjoomlacoder.com WebReserv Embedded Booking Calendar
 * @copyright		(C) 2010 myjoomlacoder.com. All rights reserved.
 * @license		GNU/GPL General Public License Version 2
 * @author		myjoomlacoder.com <admin@myjoomlacoder.com>
 * */
// no direct access
defined('_JEXEC') or die('Direct Access to this location is not allowed.');

// load Joomla's library files
jimport('joomla.plugin.plugin');
jimport('joomla.version');
jimport('joomla.html.parameter');

$app =& JFactory::getApplication();
$doc =& JFactory::getDocument();

if ($app->isAdmin()) {
     
	$document = JFactory::getDocument();
	$document->addScript(JURI::root() .'plugins/content/webreserv/jscolor/jscolor.js', 'text/javascript');

}

class plgContentWebreserv extends JPlugin {

    //------------------------BEGIN--> Webreserv plugin initialization
	
    public function plgContentWebreserv(&$subject, $config) {
		/*echo '<pre>';
		print_r($subject); die;*/
        parent::__construct($subject, $config);
        // get Joomla's version
        $version = new JVersion;
        $this->joomla = substr($version->getShortVersion(), 0, 3);

        if ($this->joomla != "1.6" and $this->joomla != "1.7") {
            $this->_plugin = JPluginHelper::getPlugin('content', 'webreserv');
            $params = new JRegistry($this->_plugin->params);
			
			$this->_params['webreserv_cal_version'] = $params->get('webreserv_cal_version');
            $this->_params['webreserv_reg_site'] = $params->get('webreserv_reg_site');
            $this->_params['webreserv_business_id'] = $params->get('webreserv_business_id');
			$this->_params['webreserv_cal_height'] = $params->get('webreserv_cal_height');
			$this->_params['webreserv_cal_width'] = $params->get('webreserv_cal_width');
            
			if($this->_params['webreserv_cal_version'] == 1){
				$this->_params['webreserv_cal_style'] = $params->get('webreserv_cal_style');
				$this->_params['webreserv_search_date'] = $params->get('webreserv_search_date');
				$this->_params['webreserv_inc_list'] = $params->get('webreserv_inc_list');
			}
			elseif( $this->_params['webreserv_cal_version'] == 2){
				$this->_params['webreserv_cal_style_v2'] = $params->get('webreserv_cal_style_v2');
				$this->_params['webreserv_search_v2'] = $params->get('webreserv_search_v2');
				$this->_params['webreserv_avail_rate_grid_v2'] = $params->get('webreserv_avail_rate_grid_v2');
				$this->_params['webreserv_color_theme_v2'] = $params->get('webreserv_color_theme_v2');
				$this->_params['webreserv_color_bg'] = $params->get('webreserv_color_bg'); 
				$this->_params['webreserv_color_txt'] = $params->get('webreserv_color_txt'); 
				$this->_params['webreserv_color_border'] = $params->get('webreserv_color_border'); 
			}
			
        } else {
            // in J1.6 - J1.7 load the language files
            $this->loadLanguage();
            $iframecode = $this->params->def(iframecode);
            $webreserv_reg_site = $this->params->def(webreserv_reg_site);
            $webreserv_business_id = $this->params->def('webreserv_business_id');
            $webreserv_cal_style = $this->params('webreserv_cal_style');
            $webreserv_search_date = $this->params('webreserv_search_date');
            $webreserv_inc_list = $this->_params('webreserv_inc_list');
        }
    }

    //------------------------END--> Webreserv plugin initialization
    //------------------------BEGIN--> function: Prepare content for Webreserv
    /*
     * Joomla 1.6 - 1.7 listening event code
     */
    public function onContentBeforeDisplay($item, &$article, &$params, $limitstart = 0) {
		
        $result = $this->onPrepareContent($article, $params, $limitstart);
    }

    /*
     * Joomla 1.5 listening event code
     */

    public function onPrepareContent(&$article, &$params, $limitstart) {

		$webreserv_reg_site = $this->_params['webreserv_reg_site'];
        $webreserv_business_id = $this->_params['webreserv_business_id'];
		$webreserv_cal_height=$this->_params['webreserv_cal_height']; 
		$webreserv_cal_width=$this->_params['webreserv_cal_width']; 
		
		$webreserv_cal_version = $this->_params['webreserv_cal_version'];
		
		if(!is_numeric($webreserv_cal_width)){
			$webreserv_cal_width = "650";
		}
		if(!is_numeric($webreserv_cal_height)){
			$webreserv_cal_height = "500";
		}
		
		if($webreserv_cal_version == 1){
		
			$webreserv_cal_style = $this->_params['webreserv_cal_style'];
			$webreserv_search_date = $this->_params['webreserv_search_date'];
			$webreserv_inc_list = $this->_params['webreserv_inc_list'];
			
			if($webreserv_cal_style=='link'){
				if($webreserv_inc_list=='y'){
				$url="https://".$webreserv_reg_site."/services/bookonline.do?businessid=".$webreserv_business_id."&search=".$webreserv_search_date;
				}else{
				$url="https://".$webreserv_reg_site."/services/bookonline.do?businessid=".$webreserv_business_id."&search=".$webreserv_search_date."&list=n";
				}
				$webreserv_code="<a href='".$url."'>Make Reservation</a>";

			}elseif($webreserv_cal_style=='embedded'){
				if($webreserv_inc_list=='y'){
				$urlembed="https://".$webreserv_reg_site."/services/bookonline.do?businessid=".$webreserv_business_id."&embedded=y&search=".$webreserv_search_date;
				}else{
				$urlembed="https://".$webreserv_reg_site."/services/bookonline.do?businessid=".$webreserv_business_id."&embedded=y&search=".$webreserv_search_date."&list=n";
				}
				$webreserv_code='<iframe src="'.$urlembed.'" width="'. $webreserv_cal_width .'px" height="'.$webreserv_cal_height.'px" scrolling="auto" frameborder="0"></iframe>';

			}elseif($webreserv_cal_style=='button'){
				if($webreserv_inc_list=='y'){
				 $urlbutton="window.location='https://".$webreserv_reg_site."/services/bookonline.do?businessid=".$webreserv_business_id."&search=".$webreserv_search_date."'";
				}else{
				 $urlbutton="window.location='https://".$webreserv_reg_site."/services/bookonline.do?businessid=".$webreserv_business_id."&search=".$webreserv_search_date."&list=n'";
				}
				$webreserv_code='<input type="button" value="Make Reservation" onclick="'.$urlbutton.'">';
			}

		}elseif( $webreserv_cal_version == 2){
			$webreserv_cal_style_v2=$this->_params['webreserv_cal_style_v2'];
			$webreserv_search_v2=$this->_params['webreserv_search_v2'];
			$webreserv_avail_rate_grid_v2=$this->_params['webreserv_avail_rate_grid_v2']; 
			$webreserv_color_theme_v2=$this->_params['webreserv_color_theme_v2'];
			$webreserv_color_bg=$this->_params['webreserv_color_bg']; 
			$webreserv_color_txt=$this->_params['webreserv_color_txt']; 
			$webreserv_color_border=$this->_params['webreserv_color_border'];
			
			if($webreserv_color_theme_v2 == 'custom'){
				$css = '&color='.$webreserv_color_txt;
				$css .= '&bgcolor='.$webreserv_color_bg;
				$css .= '&bcolor='.$webreserv_color_border;
			}else{
				$css = '&css='.$webreserv_color_theme_v2;
			}
			
			if($this->_params['webreserv_cal_style_v2']=='link'){
				$url="https://".$webreserv_reg_site."/services/bookingcalendar.do?businessid=".$webreserv_business_id."&embedded=n&search=".$webreserv_search_v2."&avgrid=".$webreserv_avail_rate_grid_v2 . $css;
				$webreserv_code="<a href='".$url."'>Make Reservation</a>";
				
			}elseif($this->_params['webreserv_cal_style_v2']=='embedded'){
				$urlembed="https://".$webreserv_reg_site."/services/bookingcalendar.do?businessid=".$webreserv_business_id."&embedded=y&search=".$webreserv_search_v2."&avgrid=".$webreserv_avail_rate_grid_v2 . $css;
				$webreserv_code='<iframe src="'.$urlembed.'" width="'. $webreserv_cal_width .'px" height="'.$webreserv_cal_height.'px" scrolling="auto" frameborder="0"></iframe>';
			}elseif($this->_params['webreserv_cal_style_v2']=='button'){
				$urlbutton="window.location='https://".$webreserv_reg_site."/services/bookingcalendar.do?businessid=".$webreserv_business_id."&embedded=n&search=".$webreserv_search_v2."&avgrid=".$webreserv_avail_rate_grid_v2 . $css ."'";
				$webreserv_code='<input type="button" value="Make Reservation" onclick="'.$urlbutton.'">';
			}
		}


        $this->_params['iframecode'] = $webreserv_code . "";
        $article->text = strtolower($article->text);
        $article->text = str_replace('{webreserv}', $this->_params['iframecode'], $article->text);
    }

}
?>
